/*
THexConv v1.0 - 11.2002

Created by NERRANT THOMAS -  MANTALOTUS
contact@thomasnerrant.com
http://thomasnerrant.com

Free for any use (commercial and non-commercial)
as long as I'm properly credited.
*/
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Hexc.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck est utilis est utilis pour tre sr que les composants crs n'ont
// aucune fonction virtuelle pure.
//

static inline void ValidCtrCheck(THexConv *)
{
        new THexConv(NULL);
}
//---------------------------------------------------------------------------
__fastcall THexConv::THexConv(TComponent* Owner)
        : inherited(Owner)
{
}
//---------------------------------------------------------------------------
namespace Hexconv
{
        void __fastcall PACKAGE Register()
        {
                 TComponentClass classes[1] = {__classid(THexConv)};
                 RegisterComponents("Mantalotus", classes, 0);
        }
}
//---------------------------------------------------------------------------
AnsiString __fastcall THexConv::Code(TStream *p)
{
AnsiString as;
try{
int size=p->Seek(0,soFromEnd);
p->Position=0;
TStringStream *pms=new TStringStream(as);
pms->CopyFrom(p,size);
pms->Position=0;
char *buf=new char[size+1];
buf[size]=0;
pms->ReadBuffer(buf,size);
pms->Position=0;
for(int i=0;i<size;i++){
AnsiString txt=IntToHex(buf[i],16);
AnsiString txt2=txt[15];
txt2=txt2+txt[16];
pms->WriteString(txt2);
}
pms->Position=0;
if(FOutputType==string)
as=pms->DataString;
else{
Output=new TStringStream(as);
Output->WriteString(pms->DataString);
Output->Position=0;
}
delete pms;
delete buf;
}catch(...){}
return as;
}
//---------------------------------------------------------------------------
AnsiString __fastcall THexConv::Decode(TStream *p)
{
AnsiString as;
try{
int size=p->Seek(0,soFromEnd);
p->Position=0;
TStringStream *pms=new TStringStream(as);
pms->CopyFrom(p,size);
pms->Position=0;
char *buf=new char[size+1];
buf[size]=0;
pms->ReadBuffer(buf,size);
pms->Position=0;
AnsiString tmp;
char t;
for(int i=0;i<size-1;i=i+2){
tmp="0x";
tmp=tmp+buf[i];
tmp=tmp+buf[i+1];
try{
t=StrToInt(tmp);
}catch(EConvertError&){
MessageDlg("Convert Error", mtError, TMsgDlgButtons() << mbOK, 0);
if(FOutputType==string)
as=pms->DataString;
else{
Output=new TStringStream(as);
Output->WriteString(pms->DataString);
Output->Position=0;
}
break;
}
pms->WriteString(t);
}
pms->Position=0;
if(FOutputType==string)
as=pms->DataString;
else{
Output=new TStringStream(as);
Output->WriteString(pms->DataString);
Output->Position=0;
}
delete buf;
delete pms;
}catch(...){}
return as;
}
//---------------------------------------------------------------------------
AnsiString __fastcall THexConv::StringCode(AnsiString p)
{
AnsiString as;
try{
if(p=="")
MessageDlg("Input AnsiString Empty", mtError, TMsgDlgButtons() << mbOK, 0);
else{
TStringStream *pms=new TStringStream(as);
pms->WriteString(p);
int size=pms->Seek(0,soFromEnd);
pms->Position=0;
char *buf=new char[size+1];
buf[size]=0;
pms->ReadBuffer(buf,size);
pms->Position=0;
for(int i=0;i<size;i++){
AnsiString txt=IntToHex(buf[i],16);
AnsiString txt2=txt[15];
txt2=txt2+txt[16];
pms->WriteString(txt2);
}
pms->Position=0;
if(FOutputType==string)
as=pms->DataString;
else{
Output=new TStringStream(as);
Output->WriteString(pms->DataString);
Output->Position=0;
}
delete pms;
delete buf;
}
}catch(...){}
return as;
}
//---------------------------------------------------------------------------
AnsiString __fastcall THexConv::StringDecode(AnsiString p)
{
AnsiString as;
try{
if(p=="")
MessageDlg("Input AnsiString Empty", mtError, TMsgDlgButtons() << mbOK, 0);
else{
TStringStream *pms=new TStringStream(as);
pms->WriteString(p);
int size=pms->Seek(0,soFromEnd);
pms->Position=0;
char *buf=new char[size+1];
buf[size]=0;
pms->ReadBuffer(buf,size);
pms->Position=0;
AnsiString tmp;
char t;
for(int i=0;i<size-1;i=i+2){
tmp="0x";
tmp=tmp+buf[i];
tmp=tmp+buf[i+1];
try{
t=StrToInt(tmp);
}catch(EConvertError&){
MessageDlg("Convert Error", mtError, TMsgDlgButtons() << mbOK, 0);
if(FOutputType==string)
as=pms->DataString;
else{
Output=new TStringStream(as);
Output->WriteString(pms->DataString);
Output->Position=0;
}
break;
}
pms->WriteString(t);
}
pms->Position=0;
if(FOutputType==string)
as=pms->DataString;
else{
Output=new TStringStream(as);
Output->WriteString(pms->DataString);
Output->Position=0;
}
delete buf;
delete pms;
}
}catch(...){}
return as;
}
//---------------------------------------------------------------------------
